package name.lamperi.orbital

import java.io.File

fun solveFile(file : File) {
    val problem = parseFile(file)
    println(problem)

    val graph = buildGraph(problem)
    println(graph)

    val solution = solveGraph("Start", "End", graph)
    println("Distance was ${solution.size} and route is $solution.")
    println(solution.map {
        val n = graph.nodes[it]!!
        n.info.point
    })
    println(solution.map {
        val n = graph.nodes[it]!!
        toVec(n.info.point).len()
    })

    val nodeList = graph.nodes.toList()
    for (i in 1..solution.size-1) {
        val a = graph.nodes[solution[i-1]]!!
        val b = graph.nodes[solution[i]]!!

        val av = toVec(a.info.point)
        val bv = toVec(b.info.point)

        val cv = bv - av

        println("From ${a.info.name} to ${b.info.name}")
        for (j in 1 .. 1000) {
            val f = j * 0.001
            val dist = (av + cv*f).len()
            if (dist < EARTH_RADIUS) {
                println(dist)
            }
        }
        println("")
    }
}

fun main(args : Array<String>) {
    //solveFile(File("src/main/resources/satellites.txt"))
    //solveFile(File("src/main/resources/satellites2.txt"))
    solveFile(File("src/main/resources/satellites3.txt"))
}